#include "cdio/compat/sector.h"

#include "string.h"


// FFI-compatible wrappings

lsn_t min_lsn() {
    return CDIO_CD_MIN_LSN;
}

lsn_t max_lsn() {
    return CDIO_CD_MAX_LSN;
}


lba_t invalid_lba() {
    return CDIO_INVALID_LBA;
}

lsn_t invalid_lsn() {
    return CDIO_INVALID_LSN;
}


size_t sizeof_msf() {
    return sizeof(msf_t);
}


unsigned int pregap_sectors() {
    return CDIO_PREGAP_SECTORS;
}

unsigned int postgap_sectors() {
    return CDIO_POSTGAP_SECTORS;
}


unsigned int cd_mins() {
    return CDIO_CD_MINS;
}

unsigned int secs_per_min() {
    return CDIO_CD_SECS_PER_MIN;
}

unsigned int frames_per_min() {
    return CDIO_CD_FRAMES_PER_MIN;
}

unsigned int frames_per_sec() {
    return CDIO_CD_FRAMES_PER_SEC;
}

unsigned int chunks_per_frame() {
    return CDIO_CD_NUM_OF_CHUNKS;
}


unsigned int min_session() {
    return CDIO_CD_MIN_SESSION_NO;
}

unsigned int max_session() {
    return CDIO_CD_MAX_SESSIONS;
}


unsigned int sync_size() {
    return CDIO_CD_SYNC_SIZE;
}

unsigned int chunk_size() {
    return CDIO_CD_CHUNK_SIZE;
}

unsigned int framesize_sub() {
    return CDIO_CD_FRAMESIZE_SUB;
}

unsigned int header_size() {
    return CDIO_CD_HEADER_SIZE;
}

unsigned int subheader_size() {
    return CDIO_CD_SUBHEADER_SIZE;
}

unsigned int edc_size() {
    return CDIO_CD_EDC_SIZE;
}

unsigned int mode1_pad_size() {
    return CDIO_CD_M1F1_ZERO_SIZE;
}

unsigned int ecc_size() {
    return CDIO_CD_ECC_SIZE;
}


unsigned int framesize() {
    return CDIO_CD_FRAMESIZE;
}

unsigned int framesize_raw() {
    return CDIO_CD_FRAMESIZE_RAW;
}

unsigned int framesize_rawer() {
    return CDIO_CD_FRAMESIZE_RAWER;
}

unsigned int framesize_raw0() {
    return CDIO_CD_FRAMESIZE_RAW0;
}

unsigned int framesize_raw1() {
    return CDIO_CD_FRAMESIZE_RAW1;
}


unsigned int header_size_xa() {
    return CDIO_CD_XA_HEADER;
}

unsigned int tail_size_xa() {
    return CDIO_CD_XA_TAIL;
}

unsigned int sync_size_xa() {
    return CDIO_CD_XA_SYNC_HEADER;
}

unsigned int data_size_xa() {
    return M2F2_SECTOR_SIZE;
}

unsigned int tagged_size_xa() {
    return M2SUB_SECTOR_SIZE;
}


const uint8_t* sector_sync_header() {
    return CDIO_SECTOR_SYNC_HEADER;
}


cdio_cd_minutes_sectors max_sectors() {
    return CDIO_CD_MAX_SECTORS;
}
