{-|
Description:    

Copyright:      (c) 2019 Sam May
License:        GPL-3.0-or-later
Maintainer:     ag@eitilt.life

Stability:      experimental
Portability:    portable
-}
module Foreign.Libcdio.Disc.Test.Classes
    ( laws
    , genDiscMode
    ) where


import qualified Hedgehog as H
import qualified Hedgehog.Gen as H.G
import qualified Hedgehog.Classes as H.C

import Foreign.Libcdio.Disc

import Test.Libcdio.Property.Common


laws :: [LawsGroup]
laws =
    [ ("DiscMode", map (\f -> f genDiscMode)
        [ H.C.eqLaws
        , ordLaws'
        , H.C.showLaws
        , H.C.showReadLaws
        , H.C.boundedEnumLaws
        ]
    )]


genDiscMode :: H.Gen DiscMode
genDiscMode = H.G.enumBounded
