{-|
Description:    

Copyright:      (c) 2019-2021 Sam May
License:        GPL-3.0-or-later
Maintainer:     ag@eitilt.life

Stability:      experimental
Portability:    portable
-}
module Main where


import qualified Control.Monad as M
import qualified System.Exit as E
import qualified Test.HUnit as U

import qualified Test.Libcdio.Upstream.Foreign.BinCue as BinCue
import qualified Test.Libcdio.Upstream.Foreign.CdrDao as CdrDao
import qualified Test.Libcdio.Upstream.Foreign.FreeBsd as FreeBsd
import qualified Test.Libcdio.Upstream.Foreign.Linux as Linux
import qualified Test.Libcdio.Upstream.Foreign.Nrg as Nrg
import qualified Test.Libcdio.Upstream.Foreign.OsX as OsX
import qualified Test.Libcdio.Upstream.Foreign.Pregap as Pregap
import qualified Test.Libcdio.Upstream.Foreign.Solaris as Solaris
import qualified Test.Libcdio.Upstream.Foreign.SizeOf as SizeOf
import qualified Test.Libcdio.Upstream.Foreign.Track as Track
import qualified Test.Libcdio.Upstream.Foreign.Win32 as Win32

import qualified Test.Libcdio.Upstream.Sound.Image as Sound.Image
import qualified Test.Libcdio.Upstream.Sound.System as Sound.System
import qualified Test.Libcdio.Upstream.Sound.Track as Sound.Track


main :: IO ()
main = do
    results <- U.runTestTT $ U.TestList
        [ BinCue.tests
        , CdrDao.tests
        , FreeBsd.tests
        , Linux.tests
        , Nrg.tests
        , OsX.tests
        , Pregap.tests
        , Solaris.tests
        , SizeOf.tests
        , Track.tests
        , Win32.tests
        , Sound.Image.tests
        , Sound.System.tests
        , Sound.Track.tests
        ]
    
    M.unless (U.errors results == 0 && U.failures results == 0) E.exitFailure
